/*
  Copyright (C) 2009 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief Esempio del gioco dei gorilla, originariamente
 *  distribuito con il Basic, reimplementato utilizzando
 *  la Very Simple Graphic Library
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 17/05/2012
 *  \date  Ultima modifica 3/06/2013
 */

 #include <math.h>

#include "vsgl_types.h"
#include "vsgl.h"

void disegna_gorilla(int x, int y)
{
    crea_rettangolo(x,y-30,6,30,ROSSO);
    crea_rettangolo(x-10,y-30,26,4,ROSSO);
    crea_cerchio(x+6/2, y-30-10, 10, ROSSO);
}

int main(int argc, char *argv[])
{
    int x = 210, y = 200;
    float s = 0, sx = 0;
    float t = 0;
    int gsx,gsy,gdx,gdy;
    float v0x, v0y;
    float angolo, forza;
    gsx = 30;
    gsy = 479;
    gdx = 600;
    gdy = 479;
    v0x = 10;
    v0y = 20;
    unsigned long oldTime, time;
    //Crea un pannello 640 x 512. Essendo il terzo parametro a 0 viene creato finestrato
    inizializza_grafica(640,512,0,"Gorilla");
    imposta_colore_sfondo(BLU_MARINO);
    crea_rettangolo(0,0,639,511,BLU_MARINO);
    crea_rettangolo(0,480,639,511,NERO);
    disegna_gorilla(gsx,gsy);
    disegna_gorilla(gdx,gdy);
    disegna_oggetti();
    scrivi(20,20,"Il fantastico gioco del gorilla", BIANCO);

    aggiorna_schermo();

    int quanto = 1;
    //Disegna a video
    int banana_rossa, banana_bianca;
    banana_rossa = crea_cerchio(x, y, 3, ROSSO );
    banana_bianca = crea_cerchio(x, y, 3, BIANCO);
    while(!done())
    {
        char input[100];
        //Primo giocatore, lancio senza scia
        disegna_oggetto(crea_rettangolo(0,480,639,31,NERO));
        leggi_stringa(input,"Inserisci l'angolo di lancio in gradi: ",0,0,482,BIANCO);
        angolo = atof(input);
        disegna_oggetto(crea_rettangolo(0,480,639,31,NERO));
        leggi_stringa(input,"Inserisci la forza di lancio: ",0,0,482,BIANCO);
        forza = atof(input);
        v0x = forza*cos(angolo/180*M_PI);
        v0y = forza*sin(angolo/180*M_PI);
        x = gsx;
        y = gsy;
        sx = 0;
        t = 0;
        time = millisecondi();
        while(y <= gdy)
        {
            //Aggiorno la situazione 10 volte al secondo
            if(time + 100 < millisecondi())
            {
                time = millisecondi();
                s = 9.81/2 * t * t - v0y*t;
                sx = sx + v0x;
                y = gsy + s*10;
                x = gsx + sx;
                muovi_oggetto(x,y,banana_rossa);
                aggiorna_schermo();
                t = t + 0.1;
                if ((x - gdx)*(x - gdx) + (y - gdy)*(y -gdy) < 900)
                {
                    scrivi(0,300,"Hai vinto");
                    aggiorna_schermo();
                    break;
                }
            }
        }
        //Secondo giocatore, lancio con scia
        disegna_oggetto(crea_rettangolo(0,480,639,31,NERO));
        leggi_stringa(input,"Inserisci l'angolo di lancio in gradi: ",0,0,482,BIANCO);
        angolo = atof(input);
        disegna_oggetto(crea_rettangolo(0,480,639,31,NERO));
        leggi_stringa(input,"Inserisci la forza di lancio: ",0,0,482,BIANCO);
        forza = atof(input);
        v0x = forza*cos(angolo/180*M_PI);
        v0y = forza*sin(angolo/180*M_PI);
        x = gdx;
        y = gdy;
        sx = 0;
        t = 0;
        time = millisecondi();
        while(y <= gdy)
        {
            if(time + 100 < millisecondi())
            {
                time = millisecondi();
                s = 9.81/2 * t * t - v0y*t;
                sx = sx + v0x;
                y = gdy + s*10;
                x = gdx - sx;
                disegna_oggetto(crea_cerchio(x, y, 3, BIANCO ));
                aggiorna_schermo();
                t = t + 0.1;
                if ((x - gsx)*(x - gsx) + (y - gsy)*(y -gsy) < 900)
                {
                    scrivi(0,300,"Hai vinto");
                    aggiorna_schermo();
                    break;
                }
            }
        }
    }
    //Attende la pressione di un tasto per continuare. Se non ci fosse
    //il programma si chiuderebbe subito senza dare il tempo di vedere quanto fatto
    pausa();
    return 0;
}

