/*
  Copyright (C) 2009 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief Programma della lumachina che mangia l'insalata
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 15/12/2011
 *  \date  Ultima modifica 3/06/2013
 */

#include "vsgl_types.h"
#include "vsgl.h"

int main(int argc, char *argv[])
{
    //Crea uno schermo 256 x 256
    inizializza_grafica(512,256,0,"Lumachina");
    int altezza = ALTEZZA_DISEGNO - 74;
    int mov_giorno = 15;
    int mov_notte = -10;
    int giorno=1;
    imposta_colore_sfondo(BIANCO);
    pulisci_schermo();
    int ret = crea_rettangolo(128,50, 10, ALTEZZA_DISEGNO - 51,ROSSO);
    int lumaca = crea_sprite(88,altezza,"snail.png");
    disegna_oggetti();
    aggiorna_schermo();
    while (altezza >  50)
    {
        if (giorno == 1)
        {
            altezza -= mov_giorno;
            muovi_oggetto(88, altezza, lumaca);
            giorno = 0;
        }
        else if (giorno == 0)
        {
            altezza -= mov_notte;
            muovi_oggetto(88, altezza, lumaca);
            giorno = 1;
        }
        aggiorna_schermo();
        ritardo(500);
    }

    //Aspetta che venga chiuso il programma
    pausa();
}

