/*
  Copyright (C) 2012 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief Esempio di utilizzo della libreria Very Simple Graphic Library
 *  per creare dei settori circolari
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 25/12/2012
 *  \date  Ultima modifica 25/12/2012
 */

#include <math.h>
#include "vsgl_types.h"
#include "vsgl.h"

const int NUM_SETTORI = 26;
const int RAGGIO = 350;

int main(int argc, char *argv[])
{
    float angolo;
    int cx, cy;
    int x,y;
    //Crea un pannello 256 x 256. Essendo il terzo parametro a 0 viene creato finestrato
    inizializza_grafica(860,860,0,"Settori circolari");
    imposta_colore_sfondo(BIANCO);
    pulisci_schermo();
    aggiorna_schermo();
    cx = LARGHEZZA_DISEGNO/2;
    cy = ALTEZZA_DISEGNO/2;
    //
    crea_cerchio(cx, cy,RAGGIO,NERO);
    crea_cerchio(cx, cy,RAGGIO*0.9,NERO);
    crea_disco(cx, cy,3,NERO);
    for (angolo = 0; angolo < 2*M_PI; angolo += M_PI*2/NUM_SETTORI)
    {
        int cix = cx + RAGGIO*sin(angolo);
        int ciy = cy + RAGGIO*cos(angolo);
        int cfx = cx + RAGGIO*0.9*sin(angolo);
        int cfy = cy + RAGGIO*0.9*cos(angolo);
        crea_linea(cix,ciy,cfx,cfy,NERO);
    }
    disegna_oggetti();
    //Tutte le funzioni di disegno non hanno effetto se non viene chimata la funzione
    //che aggiorna ciò che si vede a schermo
    aggiorna_schermo();
    //Attende la pressione di un tasto per continuare. Se non ci fosse
    //il programma si chiuderebbe subito senza dare il tempo di vedere quanto fatto
    pausa();
    pausa();
    return 0;
}

